/********************************************************************
 *	C֐    荞݃xN^[̐ݒ.
 ********************************************************************
 */
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "usb_config.h"
#include "./USB/usb_device.h"
#include "./USB/usb.h"
#include "./USB/usb_function_cdc.h"
#include "HardwareProfile.h"

 
#include "eusart.h"


#define _userap_rf
#include "userap.h"



void YourHighPriorityISRCode();
void YourLowPriorityISRCode();


//#pragma romdata EEPROM_START=0xf00000       
// rom unsigned char DefaultConfig[4] = {0x54, 0xD8, 0x32, 0x3B};

/*
#define BUF_SIZE 25
//#pragma eedata bigdata
#pragma eedata eeggaa
char  eeggaa[3]={1,2,3};

char data[11][BUF_SIZE+1] = {
  { "String #0\n\r" },
  { "String #1\n\r" },
  { "String #2\n\r" },
  { "String #3\n\r" },
  { "String #4\n\r" },
  { "String #5\n\r" },
  { "String #6\n\r" },
  { "String #7\n\r" },
  { "String #8\n\r" },
  { "String #9\n\r" },
  { "Invalid key (0-9 only)\n\r" }
};
*/
/**	VECTOR REMAPPING ***********************************************/
#if	0
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x1000
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
#endif

#if	1
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x800
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
#endif

#if	0
	#define	REMAPPED_RESET_VECTOR_ADDRESS			0x00
	#define	REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
	#define	REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
#endif

/********************************************************************
 *	0x800`̃WvxN^[ݒ肷.
 ********************************************************************
 *	0x800 goto _startup
 *	0x808 goto YourHighPriorityISRCode
 *	0x818 goto YourLowPriorityISRCode
 */

extern void	_startup (void);		// See c018i.c in your C18 compiler	dir
#pragma	code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
void _reset	(void)
{
	_asm goto _startup _endasm
}


#pragma	code REMAPPED_HIGH_INTERRUPT_VECTOR	= REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
void Remapped_High_ISR (void)
{
	 _asm goto YourHighPriorityISRCode _endasm
}


#pragma	code REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
void Remapped_Low_ISR (void)
{
	 _asm goto YourLowPriorityISRCode _endasm
}

/********************************************************************
 *	0x008`̃WvxN^[ݒ肷.
 ********************************************************************
 *	0x008 goto 0x808
 *	0x018 goto 0x818
 */
#pragma	code HIGH_INTERRUPT_VECTOR = 0x08
void High_ISR (void)
{
	 _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
}


#pragma	code LOW_INTERRUPT_VECTOR =	0x18
void Low_ISR (void)
{
	 _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
}

/********************************************************************
 *	WvxN^[ݒ͂܂.
 ********************************************************************
 */


#pragma	code
/********************************************************************
 *	High荞ݏ֐.
 ********************************************************************
 */
//#pragma	interrupt YourHighPriorityISRCode
#pragma	interrupt YourHighPriorityISRCode nosave=TBLPTR,TBLPTRU,TABLAT,PCLATH,PCLATU,PROD,section("MATH_DATA")


void YourHighPriorityISRCode()
{
	
	aptime();  //  ^C}[Ǘ

#if	USART_USE_INTERRUPT			// 荞݂gp.
	USART_RxIntHandler();
#endif

#if	defined(USB_INTERRUPT)
	USBDeviceTasks();
#endif

}	//This return will be a	"retfie fast", since this is in	a #pragma interrupt	section	

/********************************************************************
 *	Low 荞ݏ֐.
 ********************************************************************
 */
//#pragma	interruptlow YourLowPriorityISRCode
#pragma	interruptlow YourLowPriorityISRCode nosave=TBLPTR,TBLPTRU,TABLAT,PCLATH,PCLATU,PROD,section("MATH_DATA")

void YourLowPriorityISRCode()
{

#if	USART_USE_INTERRUPT			// 荞݂gp.
#if	USART_USE_TX_INTERRUPT			// 荞݂gp.
	USART_TxIntHandler();
#endif
#endif

}	//This return will be a	"retfie", since	this is	in a #pragma interruptlow section 




#pragma	code
/********************************************************************
 *
 ********************************************************************
 */
static void	InitializeSystem(void)
{
#if RAM_SERIAL
	extern void set_serial_number(void);

	set_serial_number();
#endif

	ADCON1 |= 0x0F;					// Default all pins	to digital
//	InitializeUSART();
//	mInitAllLEDs();
	USBDeviceInit();
}
/********************************************************************
 *
 ********************************************************************
 */
 void pccntl(void);
void main(void)
{
	int i;
	InitializeSystem();
	idling =1;
	userinit();
	for(i=0;i<8000;i++){
		ProcessIO();
	}
	idling =0;
	cmd_ovf=0;
	while(1){
#if	defined(USB_POLLING)
		USBDeviceTasks();
#endif
		ProcessIO();		
		pccntl();
	}
} 
/********************************************************************
 *
 ********************************************************************
 */
 

